#!/usr/bin/env python3

import numpy as np

#################### binarization from scratch ####################
# read the file "toy.txt"
lines = open("toy.txt").readlines()
# print(lines)

# process lines, remove the new line signal "\n" and split each line into two items by comma
data = [line.strip().split(", ") for line in lines]
# print(data)

# an alternative way to process lines
data = list(map(lambda line: line.strip().split(", "), lines))
# print(data)

# binarize the data
mapping = {}
new_data = []
for row in data:
    new_row = []
    for j, x in enumerate(row):
        feature = (j, x) # j is the column index and x is the value
        if feature not in mapping: # new feature
            mapping[feature] = len(mapping) # insert a new feature into the index
        new_row.append(mapping[feature])
    new_data.append(new_row)
# print(mapping)
# print(new_data)

# the number of unique binary features
num_features = len(mapping)
# print(num_features)

# binarize data
bindata = np.zeros((10, 12)) # initialize a 2D table
# print(bindata)
for i, row in enumerate(new_data): # fill in the table
    # print(i, row)
    for x in row: # for each column
        bindata[i][x] = 1
print(bindata)
